; LaunchList v1.1
; by ch1zra
; ch1zra@gmail.com
; #Sobica_Zr #Scripters @ irc.krstarica.com
; http://uptheirons.co.sr/
; Copyright  Up The Irons ! inc. Scripting Team 

; ~~~ On Load & UnLoad ~~~

on 1:load: {
  if ($version > 6.0) { 
    if ($input(LaunchList v1.1 by ch1zra loaded. $crlf Check your popups $+ $chr(44) or type "'/LList". $crlf $& 
      ch1zra@gmail.com $crlf #Scripters @ irc.krstarica.com $crlf http://uptheirons.co.sr/,o,Succes) == $true) {
      writeini mirc.ini LaunchList num 0
      llist
    }
  }
  else { 
    echo  Version 6.0 or higher required, get a newer version of mirc at http://www.mirc.com  
    unload -rs $script 
  }
}

on 1:unload: {
  if ($input(Thank you for using LaunchList v1.1 $crlf I hope you liked it :] $crlf ch1zra,o,Goodbye)) {
    if ($exists(launchlist.db)) {
      remove launchlist.db
    }
    remini mirc.ini LaunchList
    unset %llist*
  }
}

; ~~~ Aliases ~~~

alias llist {
  if ($dialog(llist)) {
    dialog -vde llist llist
  }
  else { dialog -md llist llist }
}

alias -l llist.help {
  if ($input(Launch List is easy to use addon for miRC. $crlf Simply choose which applications will launch when a $& 
    connection (to an IRC server) is detected. $crlf You might consider not to overload the list $chr(44) because $&
    your PC may crash if you give him too many "run" instructions at once. $crlf Have fun using LaunchList. $crlf $crlf ch1zra $& 
    ,o, Launch List Help)) { 
    dialog -v llist llist
  }
}

alias -l llist.about {
  if ($input(Launch List v1.1 for mIRC $crlf by ch1zra $crlf ch1zra@gmail.com $& 
    $crlf #Scripters @ irc.krstarica.com $crlf http://uptheirons.co.sr/,o,About Launch List) && ($dialog(llist))) { dialog -v llist llist }
}

alias -l llist.add {
  var %tmp $sfile(*.exe,Choose Application,&Select)
  if (%tmp != $null) {
    write launchlist.db %tmp
    writeini mirc.ini LaunchList num $calc($readini(mirc.ini, launchlist, num) + 1)
  }
  if ($dialog(llist)) { 
    dialog -v llist llist 
  }
}

alias -l llist.fill {
  did -r llist 1
  var %i 1
  var %llist $readini(mirc.ini, launchlist, num)
  while (%i <= %llist) {
    did -a llist 1 $nopath($read(launchlist.db,%i))
    inc %i
  }
} 

alias -l llist.run {
  var %i 1
  var %llist $readini(mirc.ini, launchlist, num)
  while (%i <= %llist) {
    .run $read(launchlist.db,%i)
    inc %i
  }
} 

; ~~~ Dialog ~~~

dialog llist {
  title "Launch list for mIRC"
  size -1 -1 100 65
  option dbu
  list 1, 5 5 55 60
  button "Add prog", 2, 65 5 30 10, flat
  button "Del prog", 3, 65 20 30 10, flat
  button "Run now", 4, 65 35 30 10, flat
  button "Close", 5, 65 50 30 10, flat ok
  menu "&File", 6
  item "&Settings", 7
  item "&Close", 11
  menu "&Help",8
  item "H&elp", 9
  item "&About",10
}

; ~~~  On init & close ~~~

on *:dialog:llist:init:*: {
  did -f $dname 2
  did -u $dname 1 1
  if ($exists(launchlist.db)) { llist.fill }
  else halt
}

on *:dialog:llist:close:*: { 
  unset %llist 
}

; ~~~ Menu clicks ~~~

on *:dialog:llist:menu:*: {
  if ($did == 7) { 
    if ($input(Do you want to run applications in list ON CONNECT ?,y,Settings) == $true) {
      writeini mirc.ini LaunchList sett yes
      echo -a ***LaunchList enabled
      dialog -v llist llist
    }
    else {
      writeini mirc.ini LaunchList sett no
      echo -a ***LaunchList disabled
      dialog -v llist llist
    }
  }
  if ($did == 9) {
    llist.help 
  }
  if ($did == 10) {
    llist.about 
  }
  if ($did == 11) {
    dialog -x llist llist 
  }
}

; ~~~ Dialog clicks ~~~

on *:dialog:llist:sclick:*: { 
  if ($did == 2) {
    llist.add 
    llist.fill
  }
  if ($did == 3) {
    if (%llist == $null) { 
      if ($input(Select an application,o,Error)) {
        dialog -v llist llist
      }
    }
    elseif ($input(Are you sure that you want to remove $did(1).seltext,y,Deleting) == $true) {
      write -dl $+ $did(llist,1).sel launchlist.db
      writeini mirc.ini LaunchList num $calc($readini(mirc.ini, launchlist, num) - 1)
      llist.fill
      dialog -v llist llist
    }
    else {
      echo $did(llist,1).seltext not deleted
      dialog -v llist llist
    }
  }
  if ($did == 1) {
    set %llist $did(llist,1).seltext
  }
  if ($did == 4) {
    llist.run
  }
}

; ~~~ On connect ~~~

on *:connect: {
  if ($readini(mirc.ini, LaunchList, sett) == yes) {
    llist.run
  }
  else { 
    halt
  }
}

; ~~~ Menus ~~~

menu status,channel,query {
  LaunchList:llist
}

menu menubar {
  Unload LaunchList: if ($input(Are you sure you want to unload LaunchList v1.1 ?,y, Unloading)) { unload -rs $script }
}

; LaunchList v1.1
; by ch1zra
; ch1zra@gmail.com
; #Sobica_Zr #Scripters @ irc.krstarica.com
; http://uptheirons.co.sr/
; Copyright  Up The Irons ! inc. Scripting Team 
